php是c编写,为何win下依赖vc这类c++编译器?

biean
  • 298

1.为何不同版本的php在win下,依赖的vc版本不同?
2.win+iis+isapi 下只能使用线程安全的php版本?
3.cgi默认就是进程模块?win下的cgi有线程模块的说法吗?

回复
阅读 4.3k
7 个回答

1) C++是前向兼容c的,你都跑在windows下了,当然用MS自带的IDE跟windows的结合更合适了,因为你的类库的header是MS的。
2)正解
3)跟MS有32位、64位之分一样,对应的VC也有是否支持32、64bit一说,此外,VC编译出对应的MS的runtime.dll是不一样的,具体的就是VC2012编译出的msvcrt.dll版本和VC2010是不同的,PHP如果依赖不同的runtime,是需要不同的VC去编译的

  1. win下编译c源文件,可以是用vc,mingw gcc。不过php官方说不保证mingw下可以编译,所以只能用vc了。谁也没规定vc只能编译c++不能编译c啊。
  2. php版本升级了,会使用一些新的c语言特性或者win api什么的,总之旧版本的vc不能够兼容,所以只能使用新版的vc了。又因为vc升级之后可能并不兼容旧版本,所以,老版本的php只能用旧版的vc编译了。

几位兄台的解答,基本让我搞清楚这几个问题了,多谢指点。已封贴!

我倒是想问你,为什么vc运行库更新了,php非得用老的版本?

计算机的学生基本都学习过c、c++这两种语言,c++是从c语言发展衍生过来的,c++的语法风格很类似c语言的。
1、估计随着语言的进步,php里面采用的库函数更新了,只能用更高版本的vc编译,达到相应的效果。
2、应该是服务器限制,是的
3、cgi就是输出内容处理线程,具体的说法你需要看看官方的说明文档。

1.为何不同版本的php在win下,依赖的vc版本不同?
因为不同版本的MSVC编译器编译出来的二进制文件会依赖对应版本的VC运行库.

2.win+iis+isapi 下只能使用线程安全的php版本?
在ISAPI下,IIS会把载入php5isapi.dll来调用PHP,而IIS是多线程的程序,所以要求PHP保证线程安全.

3.cgi默认就是进程模块?win下的cgi有线程模块的说法吗?
在CGI下,IIS会把PHP请求交给独立的PHP-CGI进程进行处理,IIS和PHP-CGI是不同的进程,所以跟线程扯不上关系,这时也不要求PHP线程安全.

你前三个问题都是因为没搞懂vc这个概念.
vc++是可视化IDE,全名visual c++,目前最新版本是vc++2010
你所说的vc我估计是vc运行库,在控制面板\所有控制面板项\程序和功能目录中你可以看到目前机器上安装了哪些版本的vc库,这些库过几年就会更新的

宣传栏